unit mainDragDropRows;

{$mode objfpc}{$H+}

interface

uses
  SysUtils, Forms, Controls, Grids;

type

  { TForm1 }

  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure StringGrid1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  r, c: Integer;
begin
  for r:= 0 to StringGrid1.RowCount-1 do
    for c:= 0 to StringGrid1.ColCount-1 do
      StringGrid1.Cells[c,r]:=Format('ROW%d (col%d)',[r, c]);
  StringGrid1.DragMode:=dmAutomatic;
end;

procedure TForm1.StringGrid1DragDrop(Sender, Source: TObject; X, Y: Integer);
var destRow, c:integer;
begin
  if not (Source is TStringGrid) then Exit;
  StringGrid1.MouseToCell(X, Y, c, destRow);
  StringGrid1.MoveColRow(False, TStringGrid(Source).Row, destRow);
end;

procedure TForm1.StringGrid1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var destRow, c: integer;
begin
  if (Sender<>Source) or not (Source is TStringGrid) then Exit;
  StringGrid1.MouseToCell(X, Y, c, destRow);
  Accept:=TStringGrid(Source).Row<>destRow;
end;

end.

